%define _libmoddir /lib/modules

%{!?kernel:%define kernel %(rpm -q kernel-source kernel-devel --qf "%{RPMTAG_VERSION}-%{RPMTAG_RELEASE}\\n" | tail -1)}

%define kversion %(echo "%{kernel}" | sed -e 's|-.*||')
%define krelease %(echo "%{kernel}" | sed -e 's|.*-||')

# hope we only ever get one of these
%define slc4_build %( [ "%kversion" = "2.6.9" ] && echo 1 || echo 0 )
%define slc5_build %( [ "%kversion" = "2.6.18" ] && echo 1 || echo 0 )


%define kernel26   1
%define moduledir /kernel/misc/netlog
%define kext ko
%define modules netlog2.%{kext} 


Summary: kernel module to log additional data for network connections
Name: kernel-module-netlog2-%{kernel}
Version: 1.3
Release: 1.cern
License: GPL
URL: http://isscvs.cern.ch/cgi-bin/viewcvs-all.cgi/fabric/netlog2/?cvsroot=fio#dirlist
Group: System Environment/Kernel
Source1: netlog2.stp

BuildRoot: %{_tmppath}/root-%{name}-%{version}
Prefix: %{_prefix}
%if %{slc4_build}
Exclusivearch: i686 x86_64
%else   #SLC5 can do Xen on ia64
Exclusivearch: i686 x86_64 ia64
%endif

Buildrequires: kernel = %{kernel}
BuildRequires: kernel-devel = %{kernel}
BuildRequires: kernel-debuginfo = %{kernel}
%if %{slc4_build}
Buildrequires: kernel-xenU = %{kernel}
Buildrequires: kernel-xenU-devel = %{kernel}
%else
Buildrequires: kernel-xen = %{kernel}
Buildrequires: kernel-xen-devel = %{kernel}
Buildrequires: kernel-xen-debuginfo = %{kernel}
%endif
Buildrequires: /usr/bin/stap

# all flavours of the actual kernel needs to be installed as well,
# or stap will keel over. As well as the kernel-devel-*
%ifarch i686
%if %{slc4_build}
Buildrequires: kernel-smp = %{kernel}
Buildrequires: kernel-smp-devel = %{kernel}
%else  # SLC5
Buildrequires: kernel-PAE = %{kernel}
Buildrequires: kernel-PAE-devel = %{kernel}
Buildrequires: kernel-PAE-debuginfo = %{kernel}
%endif
%endif

Requires: /boot/vmlinuz-%{kernel}
Provides: kernel-module-netlog2 = %{epoch}:%{version}-%{release}

%description
This module (actually a precompiled SystemTap script) logs additional
information for network connections.
It was built for kernel %{kversion}-%{krelease}
and architecture %{_target_cpu}.

%if %{slc4_build}
%package -n %{name}xenU
Summary: kernel module to log additional data for network connections
Group: System Environment/Kernel
Requires: /boot/vmlinuz-%{kernel}xenU
Provides: kernel-module-netlog2 = %{epoch}:%{version}-%{release}
%description -n %{name}xenU
This module (actually a precompiled SystemTap script) logs additional
information for network connections.
It was built for kernel %{kversion}-%{krelease}xenU
and architecture %{_target_cpu}.
%else
%package -n %{name}xen
Summary: kernel module to log additional data for network connections
Group: System Environment/Kernel
Requires: /boot/vmlinuz-%{kernel}xen
Provides: kernel-module-netlog2 = %{epoch}:%{version}-%{release}
%description -n %{name}xen
This module (actually a precompiled SystemTap script) logs additional
information for network connections.
It was built for kernel %{kversion}-%{krelease}xen
and architecture %{_target_cpu}.
%endif



%if %{slc4_build}
%package -n %{name}smp
Summary: kernel module to log additional data for network connections
Group: System Environment/Kernel
Requires: /boot/vmlinuz-%{kernel}smp
Provides: kernel-module-netlog2 = %{epoch}:%{version}-%{release}
%description -n %{name}smp
This module (actually a precompiled SystemTap script) logs additional
information for network connections.
It was built for kernel %{kversion}-%{krelease}smp
and architecture %{_target_cpu}.

%else
 %ifarch i686
%package -n %{name}PAE
Summary: kernel module to log additional data for network connections
Group: System Environment/Kernel
Requires: /boot/vmlinuz-%{kernel}PAE
Provides: kernel-module-netlog2 = %{epoch}:%{version}-%{release}
%description -n %{name}PAE
This module (actually a precompiled SystemTap script) logs additional
information for network connections.
It was built for kernel %{kversion}-%{krelease}PAE
and architecture %{_target_cpu}.
 %endif
%endif

%prep
%setup -c -T

cp %SOURCE1 .

%build
export TMPDIR=`pwd`

%ifarch i686
 %if %{slc4_build}
  for flavour in "" "xenU" "smp" ; do
 %else 
  for flavour in "" "xen" "PAE" ; do 
 %endif
%else
 %if %{slc4_build}
  for flavour in "" "xenU" "smp"; do 
 %else
  for flavour in "" "xen"; do 
 %endif
%endif
  /usr/bin/stap -v -v -v -g -k -p 4 -r %{kernel}${flavour} -m netlog2  %SOURCE1

  %{__install} -d -m0755 %{buildroot}%{_libmoddir}/%{kversion}-%{krelease}${flavour}%{moduledir}

  found=`find $TMPDIR -name %{modules}|/usr/bin/tail -1`;
  if [ -n "$found" ]; then
     mv -v  "$found" %{buildroot}%{_libmoddir}/%{kversion}-%{krelease}${flavour}%{moduledir}/%{modules}
     echo "######### Done with kernel flavour $flavour ###########"
  else 
    echo "kernel flavour $flavour module not found"; exit 1
  fi
done


%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%{_libmoddir}/%{kversion}-%{krelease}%{moduledir}/*

%if %{slc4_build}
%files -n %{name}smp
%defattr(-, root, root, 0755)
%{_libmoddir}/%{kversion}-%{krelease}smp%{moduledir}/*
 %else  # SLC5
 %ifarch i686
%files -n %{name}PAE
%defattr(-, root, root, 0755)
%{_libmoddir}/%{kversion}-%{krelease}PAE%{moduledir}/*
 %endif
%endif

%if %{slc4_build}
%files -n %{name}xenU
%defattr(-, root, root, 0755)
%{_libmoddir}/%{kversion}-%{krelease}xenU%{moduledir}/*
%else  # SLC5
%files -n %{name}xen
%defattr(-, root, root, 0755)
%{_libmoddir}/%{kversion}-%{krelease}xen%{moduledir}/*
%endif

%changelog
* Fri Jul 29 2011 Remi Mollon <Remi.Mollon@cern.ch> 1.3-1.cern
- Add lemon-agent to whitelisted apps

* Thu Oct 22 2009 Jan van Eldik <Jan.van.Eldik@cern.ch> 1.2-1.cern
- fix for new systemtap version 0.9.7-5.el5

* Thu Mar 12 2009 Jan Iven <jan.iven@cern.ch> 1.1-1.cern
- remote port ntoi() fix
- unified SLC4/5 versions

* Tue Sep 23 2008 Jaroslaw Polok <jaroslaw.polok@cern.ch> - 1.0-3.slc5
- Adapted for RHEL5/SL(C)5 kernels.

* Tue Jul 10 2007 Jan Iven <jan.iven@cern.ch> - 1.0-2.slc4
- take out i686-xenU since it fails to compile,
   xenU kernel up until 2.6.9-55.0.2.EL.cern did not support systemtap
- add deps on kernel-devel

* Mon Jun 25 2007 Jan Iven <jan.iven@cern.ch> - 1.0-1.slc4
- initial package
